(function () {
    "use strict";

    angular.module('core').controller('varianteBasicaDetailController', controller);
    controller.$inject = ['$scope', '$timeout', '$state', '$stateParams', 'varianteBasicaService', '$alert', 'lookupService','$q'];

    function controller($scope, $timeout, $state, $stateParams, varianteBasicaService, $alert, lookupService, $q) {
        $scope.initializeLayout('Variante Básica');

        //[Inicializa objetos]
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            vazio: false,
        };

        $scope.auxiliar = {

            tipovariantebasica: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTipoVarianteBasica({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
        };

        $scope.save = function () {
            $scope.state.salvando = true;
            varianteBasicaService
                .save($scope.state.item)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.state.salvando = false;
                        $alert({ text: response.Message, title: $scope.Title });
                    } else {
                        $scope.historyBack();
                    }
                },
                function (_error) {
                    $scope.state.salvando = false;
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                });
        }


        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            varianteBasicaService
                .get($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.item = response.Data;
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.refresh = function () {
            $scope.get();
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();